/*
 * Copyright 2022 The Furiko Authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/furiko-io/furiko/apis/execution/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeJobConfigs implements JobConfigInterface
type FakeJobConfigs struct {
	Fake *FakeExecutionV1alpha1
	ns   string
}

var jobconfigsResource = schema.GroupVersionResource{Group: "execution.furiko.io", Version: "v1alpha1", Resource: "jobconfigs"}

var jobconfigsKind = schema.GroupVersionKind{Group: "execution.furiko.io", Version: "v1alpha1", Kind: "JobConfig"}

// Get takes name of the jobConfig, and returns the corresponding jobConfig object, and an error if there is any.
func (c *FakeJobConfigs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.JobConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(jobconfigsResource, c.ns, name), &v1alpha1.JobConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.JobConfig), err
}

// List takes label and field selectors, and returns the list of JobConfigs that match those selectors.
func (c *FakeJobConfigs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.JobConfigList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(jobconfigsResource, jobconfigsKind, c.ns, opts), &v1alpha1.JobConfigList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.JobConfigList{ListMeta: obj.(*v1alpha1.JobConfigList).ListMeta}
	for _, item := range obj.(*v1alpha1.JobConfigList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested jobConfigs.
func (c *FakeJobConfigs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(jobconfigsResource, c.ns, opts))

}

// Create takes the representation of a jobConfig and creates it.  Returns the server's representation of the jobConfig, and an error, if there is any.
func (c *FakeJobConfigs) Create(ctx context.Context, jobConfig *v1alpha1.JobConfig, opts v1.CreateOptions) (result *v1alpha1.JobConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(jobconfigsResource, c.ns, jobConfig), &v1alpha1.JobConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.JobConfig), err
}

// Update takes the representation of a jobConfig and updates it. Returns the server's representation of the jobConfig, and an error, if there is any.
func (c *FakeJobConfigs) Update(ctx context.Context, jobConfig *v1alpha1.JobConfig, opts v1.UpdateOptions) (result *v1alpha1.JobConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(jobconfigsResource, c.ns, jobConfig), &v1alpha1.JobConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.JobConfig), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeJobConfigs) UpdateStatus(ctx context.Context, jobConfig *v1alpha1.JobConfig, opts v1.UpdateOptions) (*v1alpha1.JobConfig, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(jobconfigsResource, "status", c.ns, jobConfig), &v1alpha1.JobConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.JobConfig), err
}

// Delete takes name of the jobConfig and deletes it. Returns an error if one occurs.
func (c *FakeJobConfigs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(jobconfigsResource, c.ns, name, opts), &v1alpha1.JobConfig{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeJobConfigs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(jobconfigsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.JobConfigList{})
	return err
}

// Patch applies the patch and returns the patched jobConfig.
func (c *FakeJobConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.JobConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(jobconfigsResource, c.ns, name, pt, data, subresources...), &v1alpha1.JobConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.JobConfig), err
}
